﻿Imports System.IO
Imports System.Windows.Forms.DataVisualization.Charting

Public Class Form1
    Dim Hexfile(1000) As Byte
    Dim DaueranalyseLäuft As Boolean
    Dim d180 As Double
    Dim d280 As Double
    Dim d180diff As Double
    Dim d280diff As Double
    Dim zeit As DateTime
    Dim zeit2 As DateTime
    Dim startpos As Integer
    Dim endpos As Integer
    Public Structure Messpunkt
        Public Zeitpunkt As DateTime
        Public Bezug As Double 'in kWh
        Public Einspeisung As Double ' in kWh
        Public BezugLeistung As Integer 'in kWh
        Public EinspeisungLeistung As Integer ' in kWh
        Public AktLeist As Double 'in W
    End Structure
    Dim Mess(300000) As Messpunkt
    Dim Messtemp As Messpunkt
    Dim MessIndex As Long = 0 '1..10000

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Array.Clear(Hexfile, 0, 10000)
        TextBox1.Text = My.Settings.Inputfile
        TextBox2.Text = My.Settings.COMPortnummer
        Label14.Text = "0"
        DaueranalyseLäuft = False

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        My.Settings.Inputfile = TextBox1.Text
        My.Settings.COMPortnummer = TextBox2.Text
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Try
            Hexfile = My.Computer.FileSystem.ReadAllBytes(TextBox1.Text)


        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub


    Function MidByteGet(ByRef Hex1 As Byte(), ByVal Start As Integer, ByVal Länge As Integer) As Byte()
        Dim Bytefolge(Länge) As Byte
        Dim i As Integer

        For i = Start To Start + Länge
            Bytefolge(i - Start) = Hex1(i)
        Next
        Return Bytefolge
    End Function

    Public Sub MidBytePut(ByRef Hex1 As Byte(), ByVal Start As Integer, ByVal Länge As Integer, ByVal Inhalt As String)
        Dim i As Integer
        Dim l As Integer

        l = Len(Inhalt)

        For i = Start To Start + l - 1
            Hex1(i) = Convert.ToByte(Inhalt(i - Start))
        Next

        For i = Start + l To Start + Länge - 1
            Hex1(i) = 0
        Next

    End Sub
    Public Sub MidBytePutByte(ByRef Hex1 As Byte(), ByVal Start As Integer, ByVal Inhalt As Integer)

        Hex1(Start) = Convert.ToByte(Inhalt)

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Label25.Text = "unbekannt"
        If File.Exists(TextBox1.Text) Then
            Hexfile = My.Computer.FileSystem.ReadAllBytes(TextBox1.Text)
            Label23.Text = String.Format("{0:X}", CRC_Berechnen_libsml(0, 8)) '(0, 333) bei Wag)
            Analyse()
            Label28.Text = String.Format("{0:X}", Hexfile(endpos + 6)) & String.Format("{0:X}", Hexfile(endpos + 7))
            Label29.Text = String.Format("{0:X}", CRC_Berechnen_libsml(startpos, endpos + 5)) '(0, 333) bei Wag)
            If Label28.Text = Label29.Text Then
                Label22.Text = "CRC OK"
                Label22.ForeColor = Color.Lime
            Else
                Label22.Text = "Fehler in der Prüfsumme!"
                Label22.ForeColor = Color.Red
            End If
        Else
            MessageBox.Show("File existiert nicht")
            TextBox1.Focus()
        End If
    End Sub

    Private Sub Analyse()
        Dim i As Long
        Dim Zählerstand As Long
        Dim ZählerstandDouble As Double

        TextBox20.Text = ""
        For i = 0 To System.Math.Min(9, Hexfile.Length - 1)
            TextBox20.Text += Hexfile(i).ToString("X2") + " "
        Next i

        'Startsequenz
        Dim b(7) As Byte
        b(0) = &H1B
        b(1) = &H1B
        b(2) = &H1B
        b(3) = &H1B
        b(4) = &H1
        b(5) = &H1
        b(6) = &H1
        b(7) = &H1

        i = BytesSuchen(Hexfile, b, 0)

        If i = -1 Then
            Label3.Text = "nicht gefunden"
        Else
            Label3.Text = "ab Position " & i.ToString
            startpos = i
        End If

        'Endsequenz
        ReDim b(4)
        b(0) = &H1B
        b(1) = &H1B
        b(2) = &H1B
        b(3) = &H1B
        b(4) = &H1A

        i = BytesSuchen(Hexfile, b, startpos)

        If i = -1 Then
            Label4.Text = "nicht gefunden"
        Else
            Label4.Text = "ab Position " & i.ToString
            endpos = i

            TextBox20.Text += vbNewLine
            For j = i To i + 7
                TextBox20.Text += Hexfile(j).ToString("X2") + " "
            Next j
        End If


        'Zählerhersteller
        ReDim b(16)
        b(0) = &H77
        b(1) = &H7
        b(2) = &H81
        b(3) = &H81
        b(4) = &HC7
        b(5) = &H82
        b(6) = &H3
        b(7) = &HFF
        b(8) = &H1
        b(9) = &H1
        b(10) = &H1
        b(11) = &H1
        b(12) = &H4
        b(13) = &H45
        b(14) = &H4D
        b(15) = &H48
        b(16) = &H1


        i = BytesSuchen(Hexfile, b, startpos)

        If i <> -1 Then
            Label25.Text = "EMH eHz"
        End If


        b(0) = &H77
        b(1) = &H7
        b(2) = &H81
        b(3) = &H81
        b(4) = &HC7
        b(5) = &H82
        b(6) = &H3
        b(7) = &HFF
        b(8) = &H1
        b(9) = &H1
        b(10) = &H1
        b(11) = &H1
        b(12) = &H4
        b(13) = &H45
        b(14) = &H53
        b(15) = &H59
        b(16) = &H1


        i = BytesSuchen(Hexfile, b, startpos)

        If i <> -1 Then
            Label25.Text = "Easymeter Q3C"
        End If


        If Label25.Text = "EMH eHz" Then

            '1.8.0
            ReDim b(5)
            b(0) = &H77
            b(1) = &H7
            b(2) = &H1
            b(3) = &H0
            b(4) = &H1
            b(5) = &H8

            i = BytesSuchen(Hexfile, b, startpos)

            If i = -1 Then
                Label6.Text = "nicht gefunden"
            Else
                If Convert.ToInt64(Hexfile(i + 8)) = 98 Then
                    i = i + 17
                ElseIf Convert.ToInt64(Hexfile(i + 8)) = 99 Then
                    i = i + 18
                ElseIf Convert.ToInt64(Hexfile(i + 8)) = 100 Then
                    i = i + 19
                Else
                    MessageBox.Show("Lesefehler bei 1.0.1.8")
                End If
                Zählerstand = Convert.ToInt64(Hexfile(i))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 1))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 2))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 3))
                ZählerstandDouble = Zählerstand / 10000

                Label6.Text = "ab Position " & i.ToString & ": " & ZählerstandDouble.ToString & " kWh"
                d180diff = ((ZählerstandDouble - d180))
                Label19.Text = ((ZählerstandDouble - d180) * 1000).ToString("F") & " Wh"
                d180 = ZählerstandDouble
            End If

                '2.8.0
                ReDim b(5)
                b(0) = &H77
                b(1) = &H7
                b(2) = &H1
                b(3) = &H0
                b(4) = &H2
                b(5) = &H8

            i = BytesSuchen(Hexfile, b, startpos)

            If i = -1 Then
                Label9.Text = "nicht gefunden"
            Else
                If Convert.ToInt64(Hexfile(i + 8)) = 98 Then
                    i = i + 17
                ElseIf Convert.ToInt64(Hexfile(i + 8)) = 99 Then
                    i = i + 18
                ElseIf Convert.ToInt64(Hexfile(i + 8)) = 100 Then
                    i = i + 19
                Else
                    MessageBox.Show("Lesefehler")
                End If
                Zählerstand = Convert.ToInt64(Hexfile(i))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 1))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 2))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 3))
                ZählerstandDouble = Zählerstand / 10000

                Label9.Text = "ab Position " & i.ToString & ": " & ZählerstandDouble.ToString & " kWh"
                d280diff = ((ZählerstandDouble - d280))
                Label18.Text = ((ZählerstandDouble - d280) * 1000).ToString("F") & " Wh"
                d280 = ZählerstandDouble
            End If

                'akt. Leistung
                ReDim b(5)
                b(0) = &H77
                b(1) = &H7
                b(2) = &H1
                b(3) = &H0
                b(4) = &HF
                b(5) = &H7

                i = BytesSuchen(Hexfile, b, startpos)

            If i = -1 Then
                Label11.Text = "nicht gefunden"
            Else
                i = i + 15
                Zählerstand = Convert.ToInt64(Hexfile(i))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 1))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 2))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 3))
                ZählerstandDouble = Zählerstand / 10

                Label11.Text = "ab Position " & i.ToString & ": " & ZählerstandDouble.ToString & " Watt"
            End If

            'Prüfsumme
            ReDim b(4)
            b(0) = &H63
            b(1) = &H2
            b(2) = &H1
            b(3) = &H71
            b(4) = &H1

            i = BytesSuchen(Hexfile, b, startpos)

            If i = -1 Then
                Label28.Text = "nicht gefunden"
            Else
                i = i + 5
                '  Label28.Text = String.Format("{0:X}", Hexfile(333)) & " " & String.Format("{0:X}", Hexfile(334)) & " " & String.Format("{0:X}", Hexfile(335))
                '         Label29.Text = String.Format("{0:X}", CRC_Berechnen_libsml(0, 333)) '(0, 333))
            End If

        ElseIf Label25.Text = "Easymeter Q3C" Then
            '1.8.0
            ReDim b(6)
            b(0) = &H77
            b(1) = &H7
            b(2) = &H1
            b(3) = &H1
            b(4) = &H1
            b(5) = &H8
            b(6) = &H0

            i = BytesSuchen(Hexfile, b, startpos)

            If i = -1 Then
                Label6.Text = "nicht gefunden"
            Else
                i = i + 27
                Zählerstand = Convert.ToInt64(Hexfile(i))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 1))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 2))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 3))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 4))
                ZählerstandDouble = Zählerstand / 10000000

                Label6.Text = "ab Position " & i.ToString & ": " & ZählerstandDouble.ToString & " kWh"
                d180diff = ((ZählerstandDouble - d180))
                Label19.Text = ((ZählerstandDouble - d180) * 1000).ToString("F") & " Wh"
                d180 = ZählerstandDouble
            End If

            '2.8.0
            ReDim b(6)
            b(0) = &H77
            b(1) = &H7
            b(2) = &H1
            b(3) = &H1
            b(4) = &H1
            b(5) = &H8
            b(6) = &H1

            i = BytesSuchen(Hexfile, b, startpos)

            If i = -1 Then
                Label9.Text = "nicht gefunden"
            Else
                i = i + 25
                Zählerstand = Convert.ToInt64(Hexfile(i))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 1))
                Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 2))
                'Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 3))
                ZählerstandDouble = Zählerstand / 100

                Label9.Text = "ab Position " & i.ToString & ": " & ZählerstandDouble.ToString & " kWh"
                d280diff = ((ZählerstandDouble - d280))
                Label18.Text = ((ZählerstandDouble - d280) * 1000).ToString("F") & " Wh"
                d280 = ZählerstandDouble
            End If


        End If


    End Sub


    Private Function BytesSuchen(ByVal HexValues As Byte(), ByVal Data As Byte(), ByVal Start As Long) As Integer
        'Sucht Data in Hexvalues ab Position Start
        ' Alle Indices laufen ab 0
        ' Wenn nichts gefunden, wird -1 zurückgegeben

        Dim i As Long, j As Long
        Dim gefunden As Boolean

        For i = Start To UBound(HexValues) - (UBound(Data) - 1)
            gefunden = True
            For j = 0 To UBound(Data)
                If HexValues(i + j) <> Data(j) Then
                    gefunden = False
                    Exit For
                End If
            Next
            If gefunden = True Then
                BytesSuchen = i
                Exit Function
            End If
        Next i
        BytesSuchen = -1
    End Function

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged, TextBox2.TextChanged
        Label3.Text = "unbekannt"
        Label4.Text = "unbekannt"
        Label6.Text = "unbekannt"
        Label9.Text = "unbekannt"
        Label19.Text = "unbekannt"
        Label18.Text = "unbekannt"
        Label11.Text = "unbekannt"
        Label21.Text = "unbekannt"
        Label17.Text = "unbekannt"
        Label20.Text = "unbekannt"
     End Sub


    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        TextBox20.Text = ""
        Hexfile = ReceiveSerialData()
        Analyse()
        Label28.Text = String.Format("{0:X}", Hexfile(endpos + 6)) & " " & String.Format("{0:X}", Hexfile(endpos + 7))
        Label29.Text = String.Format("{0:X}", CRC_Berechnen_libsml(startpos, endpos + 5)) '(0, 333) bei Wag)

        TextBox20.Text = ""
        For i = 0 To 24
            For j = 0 To 19
                TextBox20.Text &= Hexfile(i * 20 + j) & " "
            Next
        Next

    End Sub

    Function ReceiveSerialData() As Byte()
        ' Receive strings from a serial port.
        Dim returnStr As String = ""
        Dim i As Integer
        Dim BArray(1000) As Byte

        For i = 1 To 1000
            BArray(i) = 0
        Next

        Dim com1 As IO.Ports.SerialPort = Nothing

        Try
            com1 = My.Computer.Ports.OpenSerialPort("COM" + TextBox2.Text)
            com1.Close()
        Catch ex As Exception
            MessageBox.Show("Error: Serial Port cannot be opened.")
            Return BArray
            'ReceiveSerialData = BArray
            Exit Function
        Finally
            If com1 IsNot Nothing Then com1.Close()
        End Try


        Try
            com1 = My.Computer.Ports.OpenSerialPort("COM" + TextBox2.Text)
            com1.ReadTimeout = 5000

            zeit2 = Date.Now

            For i = 0 To 599
                Label14.Text = i
                Label14.Refresh()
                Try
                    BArray(i) = com1.ReadByte() 'com1.BytesToRead
                Catch ex As TimeoutException

                End Try

            Next i


        Catch ex As TimeoutException
            returnStr = "Error: Serial Port read timed out."
        Finally
            If com1 IsNot Nothing Then com1.Close()
        End Try

        Return BArray
    End Function

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        MessageBox.Show("Mit dem Knopf Fileanalyse kann man ein Hexfile analysieren, das z.B. mit HTerm aufgenommen wurde" & vbNewLine _
                        & "Mit dem Knopf Liveanalyse werden direkt Daten von der seriellen Schnittstelle ausgewertet")

    End Sub


    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        DaueranalyseLäuft = True
        Label16.Text = 0
        Dim s As String
        Dim dauer As TimeSpan

        While DaueranalyseLäuft = True
            TextBox20.Text = ""
            Hexfile = ReceiveSerialData()
            dauer = zeit2 - zeit
            zeit = zeit2
            Analyse()
            Label28.Text = String.Format("{0:X}", Hexfile(endpos + 6)) & " " & String.Format("{0:X}", Hexfile(endpos + 7))
            Label29.Text = String.Format("{0:X}", CRC_Berechnen_libsml(startpos, endpos + 5)) '(0, 333) bei Wag)

            Label21.Text = dauer.Milliseconds.ToString & " ms"
            Label17.Text = (d180diff * 3600000 / dauer.Seconds).ToString("F") & " W"
            Label20.Text = (d280diff * 3600000 / dauer.Seconds).ToString("F") & " W"
            Label16.Text = Val(Label16.Text) + 1

            File.AppendAllText("c:\temp\FreeSolSMLLog.txt", zeit2.ToString & "; " & Label6.Text & "; " & Label9.Text & Environment.NewLine)

            s = ""
            For i = 0 To 24
                For j = 0 To 19
                    s &= Hexfile(i * 20 + j) & " "
                Next
            Next
            TextBox20.Text = s
            Me.Refresh()
            Application.DoEvents()
        End While
    End Sub




    'Private Sub PrüfsummeBerechnen()
    '    Dim crc As Integer = &HFFFF
    '    ' initial value
    '    Dim polynomial As Integer = &H1021
    '    ' 0001 0000 0010 0001  (0, 5, 12) 

    '    Dim startpos2 As Integer
    '    Dim endpos2 As Integer
    '    Dim b As Byte
    '    startpos2 = startpos + 8
    '    endpos2 = endpos - 9

    '    For j = startpos2 To endpos2
    '        b = Hexfile(j)
    '        For i As Integer = 0 To 7
    '            Dim bit As [Boolean] = ((b >> (7 - i) And 1) = 1)
    '            Dim c15 As [Boolean] = ((crc >> 15 And 1) = 1)
    '            crc <<= 1
    '            If c15 Xor bit Then
    '                crc = crc Xor polynomial
    '            End If
    '        Next
    '    Next

    '    crc = crc And &HFFFF

    '    'HB = Fix(crc / 256)    ' CRC-High-Byte
    '    'LB = crc - (256 * HB)  ' CRC-Low-Byte

    '    Label22.Text = crc.ToString("X") & " | " & Hexfile(endpos + 6).ToString("X") & "  " & Hexfile(endpos + 7).ToString("X")

    'End Sub

    'Private Sub PrüfsummeBerechnen2(ByVal startpos2 As Integer, ByVal endpos2 As Integer)
    '    Dim crc As Integer = &HFFFF
    '    ' initial value
    '    Dim polynomial As Integer = &H1021
    '    ' 0001 0000 0010 0001  (0, 5, 12) 

    '    Dim b As Byte

    '    For j = startpos2 To endpos2
    '        b = Hexfile(j)
    '        For i As Integer = 0 To 7
    '            Dim bit As [Boolean] = ((b >> (7 - i) And 1) = 1)
    '            Dim c15 As [Boolean] = ((crc >> 15 And 1) = 1)
    '            crc <<= 1
    '            If c15 Xor bit Then
    '                crc = crc Xor polynomial
    '            End If
    '        Next
    '    Next

    '    crc = crc And &HFFFF

    '    'HB = Fix(crc / 256)    ' CRC-High-Byte
    '    'LB = crc - (256 * HB)  ' CRC-Low-Byte

    '    If crc.ToString("X") = "5E2D" Then
    '        MessageBox.Show(startpos2 & " " & endpos2)
    '    End If

    '    '   File.AppendAllText("c:\temp\wagLog.txt", startpos2.ToString & " " & endpos2.ToString & " " & crc.ToString("X") & Environment.NewLine)
    '    Label22.Text += crc.ToString("X") & " | " & Hexfile(endpos + 6).ToString("X") & "  " & Hexfile(endpos + 7).ToString("X")

    'End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        DaueranalyseLäuft = False
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        MessageBox.Show("Nicht implementiert")
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Timer1.Start()
    End Sub


    Private Function Analyse2() As Messpunkt
        Dim i As Long
        Dim Zählerstand As Long
        Dim ZählerstandDouble As Double
        Dim fehler As Boolean
        Dim MT As Messpunkt

        fehler = False

        Hexfile = ReceiveSerialData()

        MT.Zeitpunkt = Now

        'Startsequenz
        Dim b(7) As Byte
        b(0) = &H1B
        b(1) = &H1B
        b(2) = &H1B
        b(3) = &H1B
        b(4) = &H1
        b(5) = &H1
        b(6) = &H1
        b(7) = &H1

        i = BytesSuchen(Hexfile, b, 0)

        If i = -1 Then
            fehler = True
        Else
            startpos = i
        End If

        'Endsequenz
        ReDim b(4)
        b(0) = &H1B
        b(1) = &H1B
        b(2) = &H1B
        b(3) = &H1B
        b(4) = &H1A

        i = BytesSuchen(Hexfile, b, 0)

        If i = -1 Then
            fehler = True
        Else
            endpos = i
        End If


        '1.8.0
        ReDim b(5)
        b(0) = &H77
        b(1) = &H7
        b(2) = &H1
        b(3) = &H0
        b(4) = &H1
        b(5) = &H8

        i = BytesSuchen(Hexfile, b, 0)

        If i = -1 Then
            fehler = True
        Else
            i = i + 17
            Zählerstand = Convert.ToInt64(Hexfile(i))
            Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 1))
            Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 2))
            Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 3))
            ZählerstandDouble = Zählerstand / 10000 'in kWh
            MT.Bezug = ZählerstandDouble

            d180diff = ((ZählerstandDouble - d180))
            d180 = ZählerstandDouble
        End If

        '2.8.0
        ReDim b(5)
        b(0) = &H77
        b(1) = &H7
        b(2) = &H1
        b(3) = &H0
        b(4) = &H2
        b(5) = &H8

        i = BytesSuchen(Hexfile, b, 0)

        If i = -1 Then
            fehler = True
        Else
            i = i + 17
            Zählerstand = Convert.ToInt64(Hexfile(i))
            Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 1))
            Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 2))
            Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 3))
            ZählerstandDouble = Zählerstand / 10000
            MT.Einspeisung = ZählerstandDouble

            d280diff = ((ZählerstandDouble - d280))
            d280 = ZählerstandDouble
        End If

        'akt. Leistung
        ReDim b(5)
        b(0) = &H77
        b(1) = &H7
        b(2) = &H1
        b(3) = &H0
        b(4) = &HF
        b(5) = &H7

        i = BytesSuchen(Hexfile, b, 0)

        If i = -1 Then
            fehler = True
        Else
            i = i + 15
            Zählerstand = Convert.ToInt64(Hexfile(i))
            Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 1))
            Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 2))
            Zählerstand = Zählerstand * 256 + Convert.ToInt64(Hexfile(i + 3))
            ZählerstandDouble = Zählerstand / 10 'in Watt
            MT.AktLeist = ZählerstandDouble

        End If

        If fehler = True Then
            MT.Einspeisung = 0
            MT.Bezug = 0
            MT.AktLeist = 0
        End If
        Return MT
    End Function

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim mtemp(3) As Messpunkt
        Dim fehler As Boolean = False
        Dim dauer As TimeSpan

        For i = 1 To 3
            Hexfile = ReceiveSerialData()
            mtemp(i) = Analyse2()
            TextBox4.Text = "Messindex: " & MessIndex & "  Durchlauf: " & i
        Next
        For i = 1 To 3
            mtemp(0).Bezug += mtemp(i).Bezug
            mtemp(0).AktLeist += mtemp(i).AktLeist
            mtemp(0).Einspeisung += mtemp(i).Einspeisung
        Next
        mtemp(0).Bezug = mtemp(0).Bezug / 3
        mtemp(0).AktLeist = mtemp(0).AktLeist / 3
        mtemp(0).Einspeisung = mtemp(0).Einspeisung / 3
        For i = 1 To 3
            If mtemp(0).Bezug <> 0 Then
                If mtemp(i).Bezug / mtemp(0).Bezug > 1.01 Or mtemp(i).Bezug / mtemp(0).Bezug < 0.99 Then
                    fehler = True
                End If
            Else
                fehler = True
            End If
            If mtemp(0).Einspeisung <> 0 Then
                If mtemp(i).Einspeisung / mtemp(0).Einspeisung > 1.01 Or mtemp(i).Einspeisung / mtemp(0).Einspeisung < 0.99 Then
                    fehler = True
                End If
            Else
                fehler = True
            End If
        Next

        TextBox4.Text += "  Fehler: " & fehler & Environment.NewLine
        If fehler = False Then
            dauer = mtemp(1).Zeitpunkt - Mess(MessIndex).Zeitpunkt
            If MessIndex > 0 Then
                mtemp(1).BezugLeistung = (mtemp(1).Bezug - Mess(MessIndex).Bezug) * 3600000 / dauer.Seconds 'in Watt
                mtemp(1).EinspeisungLeistung = (mtemp(1).Einspeisung - Mess(MessIndex).Einspeisung) * 3600000 / dauer.Seconds 'in Watt
            End If
            MessIndex += 1
            Mess(MessIndex) = mtemp(1)

            TextBox3.Text += mtemp(1).Zeitpunkt.ToString & "; " & mtemp(1).Bezug.ToString & "; " & mtemp(1).Einspeisung.ToString & "; " & mtemp(1).AktLeist.ToString & "; " & mtemp(1).BezugLeistung & "; " & mtemp(1).EinspeisungLeistung & Environment.NewLine

            File.AppendAllText("c:\temp\FreeSolSMLLog_Grafik.txt", mtemp(1).Zeitpunkt.ToString & "; " & mtemp(1).Bezug.ToString & "; " & mtemp(1).Einspeisung.ToString & "; " & mtemp(1).AktLeist.ToString & "; " & mtemp(1).BezugLeistung & "; " & mtemp(1).EinspeisungLeistung & Environment.NewLine)

            If MessIndex > 1 Then
                Chart1.Titles.Clear()
                Chart1.Titles.Clear()
                Chart1.Titles.Add("Stromzähler")
                Chart1.Series.Clear()
                Chart1.Series.Add("Einspeisung")
                Chart1.Series.Add("Bezug")
                Chart1.Series("Einspeisung").ChartType = SeriesChartType.FastLine
                Chart1.Series("Bezug").ChartType = SeriesChartType.FastLine
                For i = 2 To MessIndex
                    Chart1.Series("Einspeisung").Points.AddY(Mess(i).EinspeisungLeistung)
                    Chart1.Series("Bezug").Points.AddY(Mess(i).BezugLeistung)
                Next
                Chart1.ChartAreas(0).AxisY.Maximum = Double.NaN
                Chart1.ChartAreas(0).AxisY.Minimum = Double.NaN
                 Chart1.ResetAutoValues()
                Chart1.Invalidate()
            End If
            Application.DoEvents()

        End If

    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        File.Delete("c:\temp\FreeSolSMLLog_Grafik.txt")
        TextBox3.Text = ""
    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        Timer1.Stop()
    End Sub

    Private Function CRC_Berechnen(ByVal StartPos As Integer, ByVal EndPos As Integer) As Integer
        Dim crc As UShort
        Dim c As Integer
        Dim i As Byte
        Dim byt As Byte
        Dim crcbit As Byte
        Dim databit As Byte

        crc = &HFFFF
        For c = StartPos To EndPos
            byt = Hexfile(c)
            For i = 0 To 7
                If (crc And &H8000) Then
                    crcbit = 1
                Else
                    crcbit = 0
                End If

                If (byt And &H80) Then
                    databit = 1
                Else
                    databit = 0
                End If
                crc = crc << 1
                byt = byt << 1

                If crcbit <> databit Then
                    crc = crc Xor &H1021
                End If
            Next
        Next
        Return crc

    End Function


    'Private Function CRC_Berechnen_x25(ByVal StartPos As Integer, ByVal EndPos As Integer) As Integer
    '    Dim crc As UShort
    '    Dim i, j As Integer

    '    crc = &HFFFF&
    '    Const RefPolyX25 = &H8408&

    '    For j = StartPos To EndPos
    '        crc = crc Xor Hexfile(j)
    '        For i = 0 To 7
    '            If (crc And 1) <> 0 Then
    '                crc = ((crc \ 2) Xor RefPolyX25) And &HFFFF
    '            Else
    '                crc = (crc \ 2) And &HFFFF
    '            End If
    '        Next i
    '    Next j

    '    Return crc

    'End Function


    'Private Sub Button11_Click(sender As System.Object, e As System.EventArgs)
    '    Dim crc As UShort
    '    Dim i, j As Integer

    '    Hexfile(0) = 49
    '    Hexfile(1) = 50
    '    Hexfile(2) = 51
    '    Hexfile(3) = 52
    '    Hexfile(4) = 53
    '    Hexfile(5) = 54
    '    Hexfile(6) = 55
    '    Hexfile(7) = 56
    '    Hexfile(8) = 57

    '    crc = &HFFFF&
    '    Const RefPolyX25 = &H8408&

    '    For j = 0 To 8
    '        crc = crc Xor Hexfile(j)
    '        For i = 0 To 7
    '            If (crc And 1) <> 0 Then
    '                crc = ((crc \ 2) Xor RefPolyX25) And &HFFFF
    '            Else
    '                crc = (crc \ 2) And &HFFFF
    '            End If
    '        Next i
    '    Next j

    '    Label30.Text = String.Format("{0:X}", (Not crc) And &HFFFF)

    '    ' expected 0x906E

    'End Sub

    'Private Function CRC_Berechnen_SMLLib(ByVal StartPos As Integer, ByVal EndPos As Integer) As Integer
    '    Dim crc As UShort
    '    Dim i, j As Integer
    '    Dim byt As Byte
    '    Dim crcbit As Byte
    '    Dim databit As Byte

    '    crc = &HFFFF

    '    For j = StartPos To EndPos
    '        byt = Hexfile(j)
    '        For i = 0 To 7
    '            If (crc And &H8000) Then
    '                crcbit = 1
    '            Else
    '                crcbit = 0
    '            End If
    '            If (byt & &H80) Then
    '                databit = 1
    '            Else
    '                crcbit = 0
    '            End If
    '            crc = crc << 1
    '            byt = byt << 1
    '            If (crcbit <> databit) Then
    '                crc = crc Xor &H1021
    '            End If
    '        Next i
    '    Next j

    '    Return crc


    '    '       uint16_t crc16_ccitt(const unsigned char* data, uint32_t length) {
    '    'uint16_t crc;
    '    'uint32_t c;
    '    'uint8_t i;

    '    'uint8_t byte;
    '    'uint8_t crcbit;
    '    'uint8_t databit;

    '    'crc = 0xFFFF;
    '    'for (c = 0; c < length; c++) {
    '    '	byte = data[c];
    '    '	for (i = 0; i < 8; i++) {
    '    'crcbit = (crc & 0x8000) ? 1 : 0;
    '    'databit = (byte & 0x80) ? 1 : 0;
    '    'crc = (uint16_t)(crc << 1);
    '    'byte = (uint8_t)(byte << 1);
    '    'if (crcbit != databit) {
    '    '		crc = crc ^ 0x1021;
    '    '		}
    '    '		}
    '    '}

    '    'return crc; 

    'End Function

    Private Function CRC_Berechnen_libsml(ByVal StartPos As Integer, ByVal EndPos As Integer) As Integer
        ' table taken from DIN EN 62056-46
        Dim fcstab() As Integer = {&H0, &H1189, &H2312, &H329B, &H4624, &H57AD, &H6536, &H74BF, &H8C48,
          &H9DC1, &HAF5A, &HBED3, &HCA6C, &HDBE5, &HE97E, &HF8F7, &H1081, &H108, &H3393, &H221A, &H56A5, &H472C,
          &H75B7, &H643E, &H9CC9, &H8D40, &HBFDB, &HAE52, &HDAED, &HCB64, &HF9FF, &HE876, &H2102, &H308B, &H210,
          &H1399, &H6726, &H76AF, &H4434, &H55BD, &HAD4A, &HBCC3, &H8E58, &H9FD1, &HEB6E, &HFAE7, &HC87C, &HD9F5,
          &H3183, &H200A, &H1291, &H318, &H77A7, &H662E, &H54B5, &H453C, &HBDCB, &HAC42, &H9ED9, &H8F50, &HFBEF,
          &HEA66, &HD8FD, &HC974, &H4204, &H538D, &H6116, &H709F, &H420, &H15A9, &H2732, &H36BB, &HCE4C, &HDFC5,
          &HED5E, &HFCD7, &H8868, &H99E1, &HAB7A, &HBAF3, &H5285, &H430C, &H7197, &H601E, &H14A1, &H528, &H37B3,
          &H263A, &HDECD, &HCF44, &HFDDF, &HEC56, &H98E9, &H8960, &HBBFB, &HAA72, &H6306, &H728F, &H4014, &H519D,
          &H2522, &H34AB, &H630, &H17B9, &HEF4E, &HFEC7, &HCC5C, &HDDD5, &HA96A, &HB8E3, &H8A78, &H9BF1, &H7387,
          &H620E, &H5095, &H411C, &H35A3, &H242A, &H16B1, &H738, &HFFCF, &HEE46, &HDCDD, &HCD54, &HB9EB, &HA862,
          &H9AF9, &H8B70, &H8408, &H9581, &HA71A, &HB693, &HC22C, &HD3A5, &HE13E, &HF0B7, &H840, &H19C9, &H2B52,
          &H3ADB, &H4E64, &H5FED, &H6D76, &H7CFF, &H9489, &H8500, &HB79B, &HA612, &HD2AD, &HC324, &HF1BF, &HE036,
          &H18C1, &H948, &H3BD3, &H2A5A, &H5EE5, &H4F6C, &H7DF7, &H6C7E, &HA50A, &HB483, &H8618, &H9791, &HE32E,
          &HF2A7, &HC03C, &HD1B5, &H2942, &H38CB, &HA50, &H1BD9, &H6F66, &H7EEF, &H4C74, &H5DFD, &HB58B, &HA402,
          &H9699, &H8710, &HF3AF, &HE226, &HD0BD, &HC134, &H39C3, &H284A, &H1AD1, &HB58, &H7FE7, &H6E6E, &H5CF5,
          &H4D7C, &HC60C, &HD785, &HE51E, &HF497, &H8028, &H91A1, &HA33A, &HB2B3, &H4A44, &H5BCD, &H6956, &H78DF,
          &HC60, &H1DE9, &H2F72, &H3EFB, &HD68D, &HC704, &HF59F, &HE416, &H90A9, &H8120, &HB3BB, &HA232, &H5AC5,
          &H4B4C, &H79D7, &H685E, &H1CE1, &HD68, &H3FF3, &H2E7A, &HE70E, &HF687, &HC41C, &HD595, &HA12A, &HB0A3,
          &H8238, &H93B1, &H6B46, &H7ACF, &H4854, &H59DD, &H2D62, &H3CEB, &HE70, &H1FF9, &HF78F, &HE606, &HD49D,
          &HC514, &HB1AB, &HA022, &H92B9, &H8330, &H7BC7, &H6A4E, &H58D5, &H495C, &H3DE3, &H2C6A, &H1EF1, &HF78
        }

        Dim PPPINITFCS16 As Integer = &HFFFF   ' initial FCS value
        Dim fcs As UShort

        Dim i, j As Integer
        fcs = PPPINITFCS16

        For j = StartPos To EndPos
            i = (fcs Xor Hexfile(j)) And &HFF
            fcs = (fcs >> 8) Xor fcstab(i)
        Next j
        fcs = fcs Xor &HFFFF

        fcs = ((fcs And &HFF) << 8) Or ((fcs And &HFF00) >> 8)

        Return fcs

        'Originalcode in c
        ' #define PPPINITFCS16 0xffff	// initial FCS value

        '// table taken from DIN EN 62056-46
        'static u16 fcstab [256] = { 0x0000, 0x1189, 0x2312, 0x329b, 0x4624, 0x57ad, 0x6536, 0x74bf, 0x8c48,
        '		0x9dc1, 0xaf5a, 0xbed3, 0xca6c, 0xdbe5, 0xe97e, 0xf8f7, 0x1081, 0x0108, 0x3393, 0x221a, 0x56a5, 0x472c,
        '		0x75b7, 0x643e, 0x9cc9, 0x8d40, 0xbfdb, 0xae52, 0xdaed, 0xcb64, 0xf9ff, 0xe876, 0x2102, 0x308b, 0x0210,
        '		0x1399, 0x6726, 0x76af, 0x4434, 0x55bd, 0xad4a, 0xbcc3, 0x8e58, 0x9fd1, 0xeb6e, 0xfae7, 0xc87c, 0xd9f5,
        '		0x3183, 0x200a, 0x1291, 0x0318, 0x77a7, 0x662e, 0x54b5, 0x453c, 0xbdcb, 0xac42, 0x9ed9, 0x8f50, 0xfbef,
        '		0xea66, 0xd8fd, 0xc974, 0x4204, 0x538d, 0x6116, 0x709f, 0x0420, 0x15a9, 0x2732, 0x36bb, 0xce4c, 0xdfc5,
        '		0xed5e, 0xfcd7, 0x8868, 0x99e1, 0xab7a, 0xbaf3, 0x5285, 0x430c, 0x7197, 0x601e, 0x14a1, 0x0528, 0x37b3,
        '		0x263a, 0xdecd, 0xcf44, 0xfddf, 0xec56, 0x98e9, 0x8960, 0xbbfb, 0xaa72, 0x6306, 0x728f, 0x4014, 0x519d,
        '		0x2522, 0x34ab, 0x0630, 0x17b9, 0xef4e, 0xfec7, 0xcc5c, 0xddd5, 0xa96a, 0xb8e3, 0x8a78, 0x9bf1, 0x7387,
        '		0x620e, 0x5095, 0x411c, 0x35a3, 0x242a, 0x16b1, 0x0738, 0xffcf, 0xee46, 0xdcdd, 0xcd54, 0xb9eb, 0xa862,
        '		0x9af9, 0x8b70, 0x8408, 0x9581, 0xa71a, 0xb693, 0xc22c, 0xd3a5, 0xe13e, 0xf0b7, 0x0840, 0x19c9, 0x2b52,
        '		0x3adb, 0x4e64, 0x5fed, 0x6d76, 0x7cff, 0x9489, 0x8500, 0xb79b, 0xa612, 0xd2ad, 0xc324, 0xf1bf, 0xe036,
        '		0x18c1, 0x0948, 0x3bd3, 0x2a5a, 0x5ee5, 0x4f6c, 0x7df7, 0x6c7e, 0xa50a, 0xb483, 0x8618, 0x9791, 0xe32e,
        '		0xf2a7, 0xc03c, 0xd1b5, 0x2942, 0x38cb, 0x0a50, 0x1bd9, 0x6f66, 0x7eef, 0x4c74, 0x5dfd, 0xb58b, 0xa402,
        '		0x9699, 0x8710, 0xf3af, 0xe226, 0xd0bd, 0xc134, 0x39c3, 0x284a, 0x1ad1, 0x0b58, 0x7fe7, 0x6e6e, 0x5cf5,
        '		0x4d7c, 0xc60c, 0xd785, 0xe51e, 0xf497, 0x8028, 0x91a1, 0xa33a, 0xb2b3, 0x4a44, 0x5bcd, 0x6956, 0x78df,
        '		0x0c60, 0x1de9, 0x2f72, 0x3efb, 0xd68d, 0xc704, 0xf59f, 0xe416, 0x90a9, 0x8120, 0xb3bb, 0xa232, 0x5ac5,
        '		0x4b4c, 0x79d7, 0x685e, 0x1ce1, 0x0d68, 0x3ff3, 0x2e7a, 0xe70e, 0xf687, 0xc41c, 0xd595, 0xa12a, 0xb0a3,
        '		0x8238, 0x93b1, 0x6b46, 0x7acf, 0x4854, 0x59dd, 0x2d62, 0x3ceb, 0x0e70, 0x1ff9, 0xf78f, 0xe606, 0xd49d,
        '		0xc514, 0xb1ab, 0xa022, 0x92b9, 0x8330, 0x7bc7, 0x6a4e, 0x58d5, 0x495c, 0x3de3, 0x2c6a, 0x1ef1, 0x0f78
        '};

        'u16 sml_crc16_calculate(unsigned char *cp, int len) {
        'u16 fcs = PPPINITFCS16;

        'while (len--) {
        '	fcs = (fcs >> 8) ^ fcstab[(fcs ^ *cp++) & 0xff];
        '}

        'fcs ^= 0xffff;
        'fcs = ((fcs & 0xff) << 8) | ((fcs & 0xff00) >> 8);

        'return fcs;
        '




    End Function

   
End Class
